<script lang="ts" setup>
    import { ref, computed } from "vue";
    import { useTheme } from "vuetify";
    import {
        Chart as ChartJS,
        Title,
        Tooltip,
        Legend,
        BarElement,
        CategoryScale,
        LinearScale,
        ChartData,
        ChartDataset,
    } from "chart.js";
    import { Bar } from "vue-chartjs";

    ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale);

    const props = defineProps<{
        statistics: { [key: string]: number };
    }>();

    const theme = useTheme();

    const showDataType = ref(true);
    const showClassYear = ref(true);
    const showGender = ref(false);

    const dataTypeLabel = computed(() => (showDataType.value ? "Bestätigt" : "Warteliste"));

    const data = computed<ChartData<"bar", number[], string>>((): ChartData<"bar", number[], string> => {
        const listType = showDataType.value ? "ct" : "wl";
        const statistics = props.statistics;
        const labelsClassYear = ["5", "6", "7", "8", "9", "10", "11", "12", "13"];
        const labelsGender = {
            male: {
                label: "männlich",
                backgroundColor: theme.current.value.colors["statistics-male"],
            },
            female: {
                label: "weiblich",
                backgroundColor: theme.current.value.colors["statistics-female"],
            },
            others: {
                label: "andere",
                backgroundColor: theme.current.value.colors["statistics-others"],
            },
        };
        if (showClassYear.value) {
            let datasets: ChartDataset<"bar", number[]>[] = [];
            if (showGender.value) {
                Object.entries(labelsGender).forEach(([gender, options]) => {
                    datasets.push({
                        label: options["label"],
                        backgroundColor: options["backgroundColor"],
                        data: labelsClassYear.map((classYear) => statistics[`${listType}_${gender}_${classYear}`] ?? 0),
                    });
                });
            } else {
                datasets.push({
                    backgroundColor: theme.current.value.colors.primary,
                    data: labelsClassYear.map((classYear) => statistics[`${listType}_all_${classYear}`] ?? 0),
                });
            }
            return {
                labels: labelsClassYear,
                datasets: datasets,
            };
        }
        if (showGender.value) {
            return {
                labels: Object.values(labelsGender).map((g) => g.label),
                datasets: [
                    {
                        backgroundColor: theme.current.value.colors.primary,
                        data: Object.keys(labelsGender).map((gender) => statistics[`${listType}_${gender}_all`] ?? 0),
                    },
                ],
            };
        }
        return {
            labels: ["gesamt"],
            datasets: [
                {
                    backgroundColor: theme.current.value.colors.primary,
                    data: [statistics[`${listType}_all_all`]],
                },
            ],
        };
    });

    const options = computed(() => ({
        responsive: true,
        scales: {
            x: {
                ticks: {
                    color: theme.current.value.colors["on-background"],
                },
                grid: {
                    display: false,
                },
            },
            y: {
                beginAtZero: true,
                ticks: {
                    precision: 0,
                    color: theme.current.value.colors["on-background"],
                },
                grid: {
                    color: theme.current.value.colors["statistics-grid-color"],
                },
            },
        },
        plugins: {
            legend: {
                display: data.value.datasets.length > 1,
            },
        },
    }));
</script>

<template>
    <Bar class="v-col-12" :data="data" :options="options" />
    <v-switch class="v-col-4" inset color="primary" v-model="showDataType" :label="dataTypeLabel" />
    <v-switch class="v-col-4" inset color="primary" v-model="showClassYear" label="Klasse" />
    <v-switch class="v-col-4" inset color="primary" v-model="showGender" label="Geschlecht" />
</template>
